<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: ALM_CajaChicaArhivos.xml */
/* Generado: 2020-08-18 04:21:23 */

/* Mantenimiento de los registros de la tabla ALM_CajaChicaArhivos */
abstract class BaseALM_CajaChicaArhivosDP extends ALM_CajaChicaArhivosBV
{
    /* Constructor ( Establece los valores desde un objeto ALM_CajaChicaArhivosBN ) */
    public function __construct( ALM_CajaChicaArhivosBN $o_ALM_CajaChicaArhivosBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_ALM_CajaChicaArhivosBN ) )
        {
            $this->setByBN( $o_ALM_CajaChicaArhivosBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto ALM_CajaChicaArhivosBN */
    public function setByBN( ALM_CajaChicaArhivosBN $o_ALM_CajaChicaArhivosBN )
    {
        if ( !is_null( $o_ALM_CajaChicaArhivosBN->getIdCajaDet() ) )
        {
            $this->setIdCajaDet( $o_ALM_CajaChicaArhivosBN->getIdCajaDet() );
        }
        if ( !is_null( $o_ALM_CajaChicaArhivosBN->getIdSecuencia() ) )
        {
            $this->setIdSecuencia( $o_ALM_CajaChicaArhivosBN->getIdSecuencia() );
        }
        if ( !is_null( $o_ALM_CajaChicaArhivosBN->getNombre() ) )
        {
            $this->setNombre( $o_ALM_CajaChicaArhivosBN->getNombre() );
        }
        if ( !is_null( $o_ALM_CajaChicaArhivosBN->getTipo() ) )
        {
            $this->setTipo( $o_ALM_CajaChicaArhivosBN->getTipo() );
        }
        if ( !is_null( $o_ALM_CajaChicaArhivosBN->getTipoCompleto() ) )
        {
            $this->setTipoCompleto( $o_ALM_CajaChicaArhivosBN->getTipoCompleto() );
        }
        if ( !is_null( $o_ALM_CajaChicaArhivosBN->getTamanio() ) )
        {
            $this->setTamanio( $o_ALM_CajaChicaArhivosBN->getTamanio() );
        }
        if ( !is_null( $o_ALM_CajaChicaArhivosBN->getUbicacionURL() ) )
        {
            $this->setUbicacionURL( $o_ALM_CajaChicaArhivosBN->getUbicacionURL() );
        }
        if ( !is_null( $o_ALM_CajaChicaArhivosBN->getUbicacionFisica() ) )
        {
            $this->setUbicacionFisica( $o_ALM_CajaChicaArhivosBN->getUbicacionFisica() );
        }
        if ( !is_null( $o_ALM_CajaChicaArhivosBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_ALM_CajaChicaArhivosBN->getFechaCreacion() );
        }
        if ( !is_null( $o_ALM_CajaChicaArhivosBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_ALM_CajaChicaArhivosBN->getUsuarioCreacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_ALM_CajaChicaArhivosFN = new ALM_CajaChicaArhivosFN();
        $o_ALM_CajaChicaArhivosBN = $o_ALM_CajaChicaArhivosFN->selectByPk( $this->getIdCajaDet(), $this->getIdSecuencia() );
        if ( is_null( $o_ALM_CajaChicaArhivosBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO ALM_CajaChicaArhivos ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCajaDet() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCajaDet";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCajaDet()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSecuencia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSecuencia";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSecuencia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombre() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Nombre";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Tipo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoCompleto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoCompleto";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipoCompleto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTamanio() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Tamanio";
                $s_SQLQuery2 .= $s_Separator."".$this->getTamanio()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionURL() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UbicacionURL";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUbicacionURL()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionFisica() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UbicacionFisica";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUbicacionFisica()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE ALM_CajaChicaArhivos SET ";
            $s_Separator = "";
            if ( !is_null( $this->getNombre() ) )
            {
                $s_SQLQuery .= $s_Separator."Nombre = '".$this->getNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipo() ) )
            {
                $s_SQLQuery .= $s_Separator."Tipo = '".$this->getTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoCompleto() ) )
            {
                $s_SQLQuery .= $s_Separator."TipoCompleto = '".$this->getTipoCompleto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTamanio() ) )
            {
                $s_SQLQuery .= $s_Separator."Tamanio = ".$this->getTamanio()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionURL() ) )
            {
                $s_SQLQuery .= $s_Separator."UbicacionURL = '".$this->getUbicacionURL()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionFisica() ) )
            {
                $s_SQLQuery .= $s_Separator."UbicacionFisica = '".$this->getUbicacionFisica()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdCajaDet = ".$this->getIdCajaDet()." AND  IdSecuencia = ".$this->getIdSecuencia().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM ALM_CajaChicaArhivos WHERE  IdCajaDet = ".$this->getIdCajaDet()." AND  IdSecuencia = ".$this->getIdSecuencia().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>